/*
  AbstractRGBA.h

  Part of WiFlash_esp32

  Copyright (c) 2021 Kevin Matz (kevin.matz@gmail.com)

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/
#pragma once

#include <cstdint>
#include "AbstractFixture.h"
#include "../dmx/universe.h"

using std::uint8_t;
using std::uint16_t;

union profile_RGBA {
  uint8_t dmx[4];
  struct {
    uint8_t red;
    uint8_t green;
    uint8_t blue;
    uint8_t amber;
  } __attribute__((packed));
};

class AbstractRGBA
  : public AbstractFixture
{
public:
  AbstractRGBA(uint16_t address);

  const profile_RGBA * profile() {return &profile_;};
  virtual void recvData(DMX::Universe *); // data recieved callback

protected:
  profile_RGBA profile_;                  // dmx data
};
